Package com.macrofocus.high_d.tablelens

# Class AbstractTableLensComponent<Component,Color,Row,C>

java.lang.Object
com.macrofocus.high_d.tablelens.AbstractTableLensComponent<Component,Color,Row,C>

All Implemented Interfaces:
  `com.macrofocus.crossplatform.CPComponent<Component>`, `com.macrofocus.crossplatform.CPInteractiveComponent<Component>`, `TableLensComponent<Component,Row,C>`

Direct Known Subclasses:
  `JavaFXTableLensComponent`

public abstract class AbstractTableLensComponent<Component,Color,Row,C> extends Object implements TableLensComponent<Component,Row,C>

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `class`
  `AbstractTableLensComponent.AbstractVisualLayerIDrawing`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected final com.macrofocus.crossplatform.CPCanvas`
  `canvas`
  `protected TableLensModel<Color,Row,C>`
  `model`
  `protected final CPTimer`
  `timer`
  `protected final TableLensView<Component,Color,Row,C>`
  `view`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `AbstractTableLensComponent(TableLensView view, com.macrofocus.crossplatform.CPCanvas canvas, com.macrofocus.crossplatform.CPFactory<?,?,?,Color> factory)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addMouseListener(com.macrofocus.crossplatform.CPCanvas.MouseListener l)`
  `void`
  `addMouseMotionListener(com.macrofocus.crossplatform.CPCanvas.MouseMotionListener l)`
  `void`
  `createOverplots()`
  `Row`
  `getClosestRow(int x, int y)`
  `protected abstract int`
  `getHeight()`
  `List<Row>`
  `getRows(com.macrofocus.geom.Rectangle2D rect)`
  Returns the nodes overlapping the specified rectangle.
  `protected abstract int`
  `getWidth()`
  `protected abstract void`
  `refresh()`
  `void`
  `removeMouseListener(com.macrofocus.crossplatform.CPCanvas.MouseListener l)`
  `void`
  `removeMouseMotionListener(com.macrofocus.crossplatform.CPCanvas.MouseMotionListener l)`
  `protected abstract void`
  `repaint()`
  `void`
  `setModel(TableLensModel model)`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface com.macrofocus.crossplatform.CPComponent

  `setStyleClass`

  ### Methods inherited from interface com.macrofocus.high_d.tablelens.TableLensComponent

  `getNativeComponent, scheduleUpdate`

- ## Field Details

  - ### model

    protected TableLensModel<Color,Row,C> model

  - ### canvas

    protected final com.macrofocus.crossplatform.CPCanvas canvas

  - ### view

    protected final TableLensView<Component,Color,Row,C> view

  - ### timer

    protected final CPTimer timer

- ## Constructor Details

  - ### AbstractTableLensComponent

    protected AbstractTableLensComponent(TableLensView view, com.macrofocus.crossplatform.CPCanvas canvas, com.macrofocus.crossplatform.CPFactory<?,?,?,Color> factory)

- ## Method Details

  - ### getWidth

    protected abstract int getWidth()

  - ### getHeight

    protected abstract int getHeight()

  - ### refresh

    protected abstract void refresh()

  - ### repaint

    protected abstract void repaint()

  - ### setModel

    public void setModel(TableLensModel model)
    Specified by:
      `setModel` in interface `TableLensComponent<Component,Color,Row>`

  - ### createOverplots

    public void createOverplots()
    Specified by:
      `createOverplots` in interface `TableLensComponent<Component,Color,Row>`

  - ### getClosestRow

    public Row getClosestRow(int x, int y)
    Specified by:
      `getClosestRow` in interface `TableLensComponent<Component,Color,Row>`

  - ### getRows

    public List<Row> getRows(com.macrofocus.geom.Rectangle2D rect)
    Description copied from interface: `TableLensComponent`
    Returns the nodes overlapping the specified rectangle.
    Specified by:
      `getRows` in interface `TableLensComponent<Component,Color,Row>`
    Parameters:
      `rect` - the rectangle in screen coordinates
    Returns:
      the list of nodes

  - ### addMouseListener

    public void addMouseListener(com.macrofocus.crossplatform.CPCanvas.MouseListener l)
    Specified by:
      `addMouseListener` in interface `com.macrofocus.crossplatform.CPInteractiveComponent<Component>`

  - ### addMouseMotionListener

    public void addMouseMotionListener(com.macrofocus.crossplatform.CPCanvas.MouseMotionListener l)
    Specified by:
      `addMouseMotionListener` in interface `com.macrofocus.crossplatform.CPInteractiveComponent<Component>`

  - ### removeMouseListener

    public void removeMouseListener(com.macrofocus.crossplatform.CPCanvas.MouseListener l)
    Specified by:
      `removeMouseListener` in interface `com.macrofocus.crossplatform.CPInteractiveComponent<Component>`

  - ### removeMouseMotionListener

    public void removeMouseMotionListener(com.macrofocus.crossplatform.CPCanvas.MouseMotionListener l)
    Specified by:
      `removeMouseMotionListener` in interface `com.macrofocus.crossplatform.CPInteractiveComponent<Component>`